import { AvifEncoderOptions } from "./codecs/avif/enc";
import { WebpEncoderOptions } from "./codecs/webp/enc";
import { MozJpegEncoderOptions } from "./codecs/mozjpeg/enc";
export declare type WasmBinaries = {
    avif_dec: string;
    avif_enc: string;
    mozjpeg_dec: string;
    mozjpeg_enc: string;
    oxipng_bg: string;
    png_bg: string;
    resize_bg: string;
    webp_dec: string;
    webp_enc: string;
};
declare type EncoderOptions = {
    "image/avif": Partial<AvifEncoderOptions>;
    "image/jpeg": Partial<MozJpegEncoderOptions>;
    "image/webp": Partial<WebpEncoderOptions>;
    "image/png": void;
};
export declare class Squoll {
    #private;
    constructor(options: {
        worker: () => Promise<Worker>;
        wasmBinaries: WasmBinaries;
        maxThreads?: number;
        maxTasksPerThread?: number;
    });
    decode(blob: File | Blob): Promise<ImageData | null>;
    resize({ source, width, height, }: {
        source: ImageData;
        width: number;
        height: number;
    }): Promise<ImageData>;
    encode<T extends keyof EncoderOptions>({ source, type, options, }: {
        source: ImageData;
        type: T;
        options?: EncoderOptions[T];
    }): Promise<Blob | null>;
}
export {};
