import type { AvifEncoderOptions } from "@/codecs/avif/enc";
import type { OxipngOptions } from "@/codecs/oxipng/oxipng";
import type { MozJpegEncoderOptions } from "@/codecs/mozjpeg/enc";
import type { WebpEncoderOptions } from "@/codecs/webp/enc";
import type { WasmBinaries } from "@/squoll";
declare type Encoder<T> = (payload: {
    source: ImageData;
    options?: Partial<T>;
    wasmBinaries: WasmBinaries;
}) => Promise<Blob | null>;
declare type Decoder = (payload: {
    blob: File | Blob;
    wasmBinaries: WasmBinaries;
}) => Promise<ImageData | null>;
export declare type SquollWorker = {
    decodeAvif: Decoder;
    decodeMozjpeg: Decoder;
    decodePng: Decoder;
    decodeWebp: Decoder;
    encodeAvif: Encoder<AvifEncoderOptions>;
    encodeMozjpeg: Encoder<MozJpegEncoderOptions>;
    encodeWebp: Encoder<WebpEncoderOptions>;
    encodePng: Encoder<OxipngOptions>;
    resize(payload: {
        source: ImageData;
        width?: number;
        height?: number;
        wasmBinaries: WasmBinaries;
    }): Promise<ImageData>;
};
export {};
